//program quartet.c
/*********************************/
/* tranceformation70000񑱂 */
/* ̂ƂS(T)\            */
/*********************************/
#include<stdio.h>
#include<time.h>
#include<stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include<iostream.h>
#include<LEDA/graphwin.h>
#include<LEDA/graph.h>
#include<LEDA/p_queue.h>
#include<LEDA/graph_alg.h>
#include<LEDA/array.h>
#define SIZE 200

using namespace leda;

void quartet(graph& G,int n,node leaf[SIZE],node in_n[SIZE],edge e[SIZE]);
void copy_G(const graph& d_G,graph& G,int n,const node d_leaf[SIZE],node leaf[SIZE],const node d_in_n[SIZE],node in_n[SIZE],const edge d_e[SIZE],edge e[SIZE]);
void leaf_swap(graph& G,int n,node leaf[SIZE],node in_n[SIZE],edge e[SIZE]);
void subtree_swap(graph& G,int n,node in_n[SIZE],edge e[SIZE]);
void trancefer(graph& G,int n,edge e[SIZE]);
//void dijkstra(graph& G,node s,const edge_array<int>& cost,node_array<int>& dist,node_array<edge>& pred);
double loop(graph& G,int n,double dis[SIZE][SIZE]);
double quartet_cost(graph& G,int n,double dis[SIZE][SIZE],int a,int b,int c,int d);
double distance(char filename[SIZE][SIZE]);
int listup(char name[SIZE][SIZE]);
double min_cost(double dis[SIZE][SIZE],int n);
double max_cost(double dis[SIZE][SIZE],int n);
void set_name(char filename[SIZE][SIZE],int n,char dir[SIZE],char name[SIZE][SIZE],char option[SIZE],double dis[SIZE][SIZE]);

int main(void){

  char name[SIZE][SIZE]={0};//{t@Ci[
  char dir[SIZE]={0};  //fBNg
  char option[SIZE]={".mid.bz2"};   //gqt
  char filename[SIZE][SIZE]={0};      //t@C
  char *p;   //ʒu\|C^
  int fsize[SIZE]={0};
  double dis[SIZE][SIZE]={0};
  double min,max,q_cost,G_cost,G_ST,ST;

  int i,j; //JEgpϐ
  int n; //f[^
  int shuffle,k;
  int count=0;

  do{
    n=listup(name);
    if(n<3){
      puts("Please input number more than 3!");
    }
  }while(n<3);

  srand((unsigned)time(NULL) % RAND_MAX);
  
  printf("fBNg͂Ă:");
  scanf("%s",dir);
  
  set_name(filename,n,dir,name,option,dis);

  graph G,d_G;
  GraphWin gw(1000,800);
  G.make_undirected();
  gw.set_edge_direction(undirected_edge);
  gw.set_node_label_type(user_label);
  //gw.set_node_label_font(roman_font,11);

  node leaf[n]; //datanode^̔z
  node in_n[n-2]; //inner nodenode^̔z
  node d_leaf[n]; //datanode^̔z _~[
  node d_in_n[n-2]; //inner nodenode^̔z _~[

  edge e[2*n-3];
  edge d_e[2*n-3];

  quartet(G,n,leaf,in_n,e);

  min=min_cost(dis,n);
  max=max_cost(dis,n);

  /* ***make dummy*** */
  d_G=G;
  node w;
  forall_nodes(w,d_G){
    if(index(w)<n){
    d_leaf[index(w)]=w;
    }else{
    d_in_n[index(w)-n]=w;
    }
  }
  edge eg;
  forall_edges(eg,d_G){
    d_e[index(eg)]=eg;
  }
  /* ***make dummy*** */

  G_cost=loop(G,n,dis);
  G_ST=(G_cost-max) / (min-max);

  /* *****tranceformation***** */
  do{
    k=20;
    do{
      shuffle=rand()%3;

      if(shuffle==0){
	leaf_swap(d_G,n,d_leaf,d_in_n,d_e);
      }else if(shuffle==1){
	subtree_swap(d_G,n,d_in_n,d_e);
      }else if(shuffle==2){
	trancefer(d_G,n,d_e);
      }
      k--;
    }while(k>0);
  
    q_cost=loop(d_G,n,dis);
    ST=(q_cost-max) / (min-max);
  
    if(ST>G_ST){
      copy_G(d_G,G,n,d_leaf,leaf,d_in_n,in_n,d_e,e);
      G_ST=ST;
      cout << "Graph G's S(T):" << G_ST << endl;
    }
    count++;
    //cout << count << endl;
  }while(count < 4500);
  /* *****tranceformation***** */

  cout << "data:" << n << endl;
  cout << "max cost:" << max << endl;
  cout << "min cost:" << min << endl;
  cout << "Graph G's cost:" << G_cost << endl;
  cout << "Graph G's S(T):" << G_ST << endl;
  cout << "trancefer:" << count << endl;
  
  gw.set_graph(G);

  for(i=0;i<n;i++){
    gw.set_label(leaf[i],name[i]);
  }

  node v;
  forall_nodes(v,G){
    if(index(v)<n){
      gw.set_shape(v,ellipse_node);
      gw.set_width(v,60);
      gw.set_height(v,15);
    }else{
      gw.set_width(v,3);
      gw.set_height(v,3);
    }
  }

  gw.display();
  gw.edit();

  return(0);
}

void quartet(graph& G,int n,node leaf[],node in_n[],edge e[]){

  int i,j,m;
  int deg,ed;
  int a,b,c;

  for(i=0;i<n;i++){ //OtGnode
    leaf[i]=G.new_node();
  }

  for(i=0;i<n-2;i++){ //OtGnode
    in_n[i]=G.new_node();
  }


  for(j=0;j<n/2;j++){ //subtree

    while(true){
      a=rand()%n;
      b=rand()%n;
      c=rand()%(n-2);

      if(a!=b){//t̂̂łȂASĂnode̎0̂Ƃ邱Ƃł
	if(G.degree(leaf[a])==0 && G.degree(leaf[b])==0 && G.degree(in_n[c])==0){
	  break;
	}
      }
    }

    m=n/2;
    e[j]=G.new_edge(in_n[c],leaf[a]);
    e[j+m]=G.new_edge(in_n[c],leaf[b]);

    ed=j+m+1;
  }

  do{
    m=0;

    if(n<=4)
      break;

    while(true){ //0inner nodeT
      a=rand()%(n-2);
      if(G.degree(in_n[a])==0){
	break;
      }
    }

    while(true){ //2inner nodeT
      b=rand()%(n-2);
      if(G.degree(in_n[b])==2){
	break;
      }
    }

    while(true){ //2inner nodeT
      c=rand()%(n-2);
      if(G.degree(in_n[c])==2 && c != b){
	break;
      }
    }

    e[ed]=G.new_edge(in_n[a],in_n[b]);
    e[ed+1]=G.new_edge(in_n[a],in_n[c]);
    ed=ed+2;

    for(j=0;j<n-2;j++){ //0inner node邩ǂ𔻒

      deg=G.degree(in_n[j]);
  
      if(deg==0){
	m=1;
      }
    }

  }while(m==1); //0inner node葱
 
  if(n%2==0){ //t̐Ȃ΁A2inner nodem
    for(i=0;i<n-2;i++){
      if(G.degree(in_n[i])==2){
	a=i;
	break;
      }
    }
    for(i=a+1;i<n-2;i++){
      if(G.degree(in_n[i])==2){
	b=i;
	break;
      }
    }
    e[ed]=G.new_edge(in_n[a],in_n[b]);

  }else{ //t̐Ȃ΁A0̗tƎ2inner node
    for(i=0;i<n;i++){
      if(G.degree(leaf[i])==0){
	a=i;
	break;
      }
    }
    for(i=0;i<n-2;i++){
      if(G.degree(in_n[i])==2){
	b=i;
	break;
      }
    }
    e[ed]=G.new_edge(in_n[b],leaf[a]);
  }

}

void copy_G(const graph& d_G,graph& G,int n,const node d_leaf[SIZE],node leaf[SIZE],const node d_in_n[SIZE],node in_n[SIZE],const edge d_e[SIZE],edge e[SIZE]){

  G=d_G;
  node w;
  forall_nodes(w,G){
    if(index(w)<n){
    leaf[index(w)]=w;
    }else{
    in_n[index(w)-n]=w;
    }
  }
  edge eg;
  forall_edges(eg,G){
    e[index(eg)]=eg;
  }

}

void leaf_swap(graph& G,int n,node leaf[],node in_n[],edge e[]){
  /* **********leaf swap********** */
  
  int a,b;

  a=rand()%n; //tI
  do{
    b=rand()%n;
  }while(a==b);

  edge_array<int> cost(G,1);
  node_array<int> dist(G,MAXINT);
  node_array<edge> pred(G);

  //dijkstra(G,leaf[a],cost,dist,pred);
  DIJKSTRA_T(G,leaf[a],cost,dist,pred);

  node v,u;
  edge eg,eg_a,eg_b;
  forall_nodes(v,G){

    if(v==leaf[b]){
      eg_b=pred[v];
      u=v;
      while(eg=pred[u]){
	if(u==G.source(eg)){
	  u=G.target(eg);
	}else{
	  u=G.source(eg);
	}
	eg_a=eg;
      }
    }
  }

  node ch_na,ch_nb; //ꂼ̐ڑnode
  if(leaf[a]==source(eg_a)){
    ch_na=target(eg_a);
  }else{
    ch_na=source(eg_a);
  }
  
  if(leaf[b]==source(eg_b)){
    ch_nb=target(eg_b);
  }else{
    ch_nb=source(eg_b);
  }

  G.del_edge(eg_a);
  G.del_edge(eg_b);
  
  e[index(eg_a)]=G.new_edge(ch_nb,leaf[a]);
  e[index(eg_b)]=G.new_edge(ch_na,leaf[b]);
  
  /* **********end********** */

}

void subtree_swap(graph& G,int n,node in_n[],edge e[]){
  /* **********subtree swap********** */  
  int a,b;

  a=rand()%(n-2); //inner nodeI
  do{
    b=rand()%(n-2);
  }while(a==b);

  edge_array<int> cost(G,1);
  node_array<int> dist(G,MAXINT);
  node_array<edge> pred(G);

  //  dijkstra(G,in_n[a],cost,dist,pred);
  DIJKSTRA_T(G,in_n[a],cost,dist,pred);

  node v,u;
  edge eg,eg_a,eg_b;
  forall_nodes(v,G){

    if(v==in_n[b]){
      eg_b=pred[v];
      u=v;
      while(eg=pred[u]){
	if(u==G.source(eg)){
	  u=G.target(eg);
	}else{
	  u=G.source(eg);
	}
	eg_a=eg;
      }
    }
  }

  if(dist[in_n[b]]>2){

    node ch_na,ch_nb;
    if(in_n[a]==source(eg_a)){
      ch_na=target(eg_a);
    }else{
      ch_na=source(eg_a);
    }
    
    if(in_n[b]==source(eg_b)){
      ch_nb=target(eg_b);
    }else{
      ch_nb=source(eg_b);
    }
    
    G.del_edge(eg_a);
    G.del_edge(eg_b);
    
    e[index(eg_a)]=G.new_edge(ch_nb,in_n[a]);
    e[index(eg_b)]=G.new_edge(ch_na,in_n[b]);

  }
  /*  **********end********** */
}

void trancefer(graph& G,int n,edge e[SIZE]){
  /* **********trancefer********** */  
  int a,b;

  a=rand()%(2*n-2);
  do{
    b=rand()%(2*n-2);
  }while(a==b || (a<n && b<n));
  
  edge_array<int> cost(G,1);
  node_array<int> dist(G,MAXINT);
  node_array<edge> pred(G);
  
  node na,nb,nd;
  
  forall_nodes(nd,G){
    if(index(nd)==a){
      na=nd;
    }else if(index(nd)==b){
      nb=nd;
    }
  }

  //  dijkstra(G,na,cost,dist,pred);
  DIJKSTRA_T(G,na,cost,dist,pred);

  node v,u;
  edge eg;
  edge eg_a,eg_b;
  forall_nodes(v,G){
    if(v==nb){
      eg_b=pred[v];
      u=v;
      while(eg=pred[u]){
	if(u==G.source(eg)){
	  u=G.target(eg);
	}else{
	  u=G.source(eg);
	}
	eg_a=eg;
      }
    }
  }


  if(dist[nb]>2){
    node a_adj;
    if(na==source(eg_a)){
      a_adj=target(eg_a);
    }else{
      a_adj=source(eg_a);
    }

    G.del_edge(eg_a);

    edge adj_1,adj_2;
    adj_1=G.first_adj_edge(a_adj);
    adj_2=G.last_adj_edge(a_adj);
  
    G.del_edge(adj_1);
    G.del_edge(adj_2);

    if(a_adj==source(adj_1)){
      if(a_adj==source(adj_2)){
	e[index(adj_2)]=G.new_edge(target(adj_1),target(adj_2));
      }else{
	e[index(adj_2)]=G.new_edge(target(adj_1),source(adj_2));
      }
    }else{
      if(a_adj==source(adj_2)){
	e[index(adj_2)]=G.new_edge(source(adj_1),target(adj_2));
      }else{
	e[index(adj_2)]=G.new_edge(source(adj_1),source(adj_2));
      }
    }

    node b_adj;
    if(nb==source(eg_b)){
      b_adj=target(eg_b);
    }else{
      b_adj=source(eg_b);
    }

    G.del_edge(eg_b);
    e[index(eg_a)]=G.new_edge(a_adj,b_adj);
    e[index(eg_b)]=G.new_edge(a_adj,na); 
    e[index(adj_1)]=G.new_edge(a_adj,nb);

    /* **********end********** */ 
  }
}
/*
void dijkstra(graph& G,node s,const edge_array<int>& cost,node_array<int>& dist,node_array<edge>& pred){

  p_queue<int,node> PQ;
  node_array<pq_item> I(G);
  int c;

  node u,v;
  edge e;
  dist[s]=0;
  I[s]=PQ.insert(0,s);

  forall_nodes(v,G){
    I[v]=PQ.insert(dist[v],v);
  }
  
  while(!PQ.empty()){
    pq_item it=PQ.find_min();
    u=PQ.inf(it);
    PQ.del_item(it);
    forall_adj_edges(e,u){
      v=target(e);
      if(v==u){
	v=source(e);
      }
      c=dist[u]+cost[e];
            
      if(c<dist[v]){
	PQ.decrease_p(I[v],c);
	dist[v]=c;
	pred[v]=e;

      }
    }
  }
}
*/

double loop(graph& G,int n,double dis[SIZE][SIZE]){
  int a,b,c,d;
  double cost=0;

  for(a=0;a<n-3;a++){
    for(b=a+1;b<n-2;b++){
      for(c=b+1;c<n-1;c++){
	for(d=c+1;d<n;d++){
	  cost=cost+quartet_cost(G,n,dis,a,b,c,d);
	}
      }
    }
  }

  return(cost);
}

double quartet_cost(graph& G,int n,double dis[SIZE][SIZE],int a,int b,int c,int d){
  int a_to[SIZE]={0};
  int d_to[SIZE]={0};
  int i=0,j=0;
  int x=0,y=0;
  double q_cost;
  edge_array<int> cost(G,1);
  node_array<int> dist_a(G,MAXINT);
  node_array<int> dist_d(G,MAXINT);
  node_array<edge> pred_a(G);
  node_array<edge> pred_d(G);

  node v,na,nb,nc,nd;
  forall_nodes(v,G){
    if(index(v)==a){
      na=v;
    }else if(index(v)==b){
      nb=v;
    }else if(index(v)==c){
      nc=v;
    }else if(index(v)==d){
      nd=v;
    }
  }
  //  dijkstra(G,na,cost,dist_a,pred_a);
  //  dijkstra(G,nd,cost,dist_d,pred_d);
  DIJKSTRA_T(G,na,cost,dist_a,pred_a);
  DIJKSTRA_T(G,nd,cost,dist_d,pred_d);

  edge e;
  node u,w;

  /**************Check quartet (ab|cd)***************/

  forall_nodes(w,G){
    if(w==nb){
      u=w;
      while(e=pred_a[u]){
	if(u==G.source(e)){
	  u=G.target(e);
	}else{
	  u=G.source(e);
	}
	a_to[i]=index(u);
	i++;
      }
    }else if(w==nc){
      u=w;
      while(e=pred_d[u]){
	if(u==G.source(e)){
	  u=G.target(e);
	}else{
	  u=G.source(e);
	}
	d_to[j]=index(u);
	j++;
      }
    }
  }

  for(i=0;i<dist_a[nb];i++){
    for(j=0;j<dist_d[nc];j++){
      if(a_to[i]==d_to[j]){
	x=1;
	break;
      }
    }
  }

  /**************Check quartet (ab|cd)***************/
  i=0;
  j=0;
  /**************Check quartet (ac|bd)***************/

  forall_nodes(w,G){
    if(w==nc){
      u=w;
      while(e=pred_a[u]){
	if(u==G.source(e)){
	  u=G.target(e);
	}else{
	  u=G.source(e);
	}
	a_to[i]=index(u);
	i++;
      }
    }else if(w==nb){
      u=w;
      while(e=pred_d[u]){
	if(u==G.source(e)){
	  u=G.target(e);
	}else{
	  u=G.source(e);
	}
	d_to[j]=index(u);
	j++;
      }
    }
  }

  for(i=0;i<dist_a[nc];i++){
    for(j=0;j<dist_d[nb];j++){
      if(a_to[i]==d_to[j]){
	y=1;
	break;
      }
    }
  }

  /**************Check quartet (ac|bd)***************/

  if(x==1 && y==1){
    q_cost=dis[a][d]+dis[b][c];
  }else if(x==0){
    q_cost=dis[a][b]+dis[c][d];
  }else if(y==0){
    q_cost=dis[a][c]+dis[b][d];
  }else{
    cout << "Error!!" << endl;
  }

  return(q_cost);
}

double distance(char filename[][SIZE]){
  
  FILE *fn;
  int i;
  int fsize[SIZE]={0};     //ꂼ̃t@CTCYL
  struct stat size;        //stat\̕ϐ(oCg)
  double dis;                 //filename[0]filename[1]̋
  
  for(i=0;i<3;i++){
    fn=fopen(filename[i], "r");
    if(fn==NULL){
      printf("File is not open!.\n");
      exit(0);
    }
    if( stat (filename[i], &size ) == 0){
      fsize[i]=size.st_size;
    }else{
      printf("Can't measure the file!");
      fclose(fn);
      exit(0);
    }
    fclose(fn);
  }
  
  //vZ

  if(fsize[0]>fsize[1]){
    dis=(double)(fsize[2]-fsize[1]) / fsize[0];
  }else{
    dis=(double)(fsize[2]-fsize[0]) / fsize[1];
  }

  return(dis);

}

int listup(char name[][SIZE]){
  FILE *fn;
  int i=0,j,n;
  char buf[SIZE];
  register char *c;
  
  fn=fopen("list.txt", "r");
  if(fn==NULL){
    printf("File is not open!.\n");
    exit(0);
  }
  while(fgets(buf,sizeof(buf),fn)!=NULL){
    c=strchr(buf,'\n');
    *c='\0';
    strcpy(name[i],buf);
    i++;
  }

  fclose(fn);

  n=i;

  return(n);
}

double min_cost(double dis[][SIZE],int n){
  int i,j,k,l;
  double min=0,tmp;

  for(i=0;i<n-3;i++){
    for(j=i+1;j<n-2;j++){
      for(k=j+1;k<n-1;k++){
	for(l=k+1;l<n;l++){
	  tmp=dis[i][j]+dis[k][l];
	  if(tmp>dis[i][k]+dis[j][l]){
	    tmp=dis[i][k]+dis[j][l];
	  }
	  if(tmp>dis[i][l]+dis[j][k]){
	    tmp=dis[i][l]+dis[j][k];
	  }
	  min=min+tmp;
	}
      }
    }
  }
  return(min);
}

double max_cost(double dis[][SIZE],int n){
  int i,j,k,l;
  double max=0,tmp;

  for(i=0;i<n-3;i++){
    for(j=i+1;j<n-2;j++){
      for(k=j+1;k<n-1;k++){
	for(l=k+1;l<n;l++){
	  tmp=dis[i][j]+dis[k][l];
	  if(tmp<dis[i][k]+dis[j][l]){
	    tmp=dis[i][k]+dis[j][l];
	  }
	  if(tmp<dis[i][l]+dis[j][k]){
	    tmp=dis[i][l]+dis[j][k];
	  }
	  max=max+tmp;
	}
      }
    }
  }
  return(max);
}

void set_name(char filename[SIZE][SIZE],int n,char dir[SIZE],char name[SIZE][SIZE],char option[SIZE],double dis[SIZE][SIZE]){

  int i,j;

  for(i=0;i<n-1;i++){
    strcpy(filename[0],dir);
    strcat(filename[0],name[i]);
    strcat(filename[0],option);

    for(j=i+1;j<n;j++){
      strcpy(filename[1],dir);
      strcat(filename[1],name[j]);
      strcat(filename[1],option);
      
      strcpy(filename[2],dir);
      strcat(filename[2],name[i]);
      strcat(filename[2],"_");
      strcat(filename[2],name[j]);
      strcat(filename[2],option);

      strcpy(filename[3],dir);
      strcat(filename[3],name[j]);
      strcat(filename[3],"_");
      strcat(filename[3],name[i]);
      strcat(filename[3],option);

      dis[i][j]=distance(filename);
    }
  }
}
